#property copyright "for-good-letters@yandex.ru"
#property link      "for-good-letters@yandex.ru"

/*
          
*/

#property indicator_chart_window

extern double Level=1.618;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init(){
   Comment("");
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit(){
   Comment("");
   ObjectDelete("Cross");
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start(){   

   string FChanName="FC";
   string TName="TL";
   double fx1;
   double fy1;
   double fx2;
   double fy2;
   double fx3;
   double fy3;
   double tx1;
   double ty1;
   double tx2;
   double ty2;   
   double Value;

   double cx,cy;
   string cs="";

   FiboChanGetCoords(FChanName,fx1,fy1,fx2,fy2,fx3,fy3); //   ,   .  -  
   cs=cs+": x1="+fx1+", y1="+fy2+", x2="+fx2+", y2="+fy2+", x3="+fx3+", y3="+fy3+"\n";
   TrendLnGetCoords(TName,tx1,ty1,tx2,ty2); //    ,  ,  -  
   cs=cs+" : x1="+tx1+", y1="+ty2+", x2="+tx2+", y2="+ty2+"\n";

   if(FiboChanLevelAndTrendLnCross(fx1,fy1,fx2,fy2,fx3,fy3,Level,tx1,ty1,tx2,ty2,cx,cy)){ //   .   , ,   ,   
      cs=cs+": x="+cx+", y="+cy;
      int x=MathRound(cx);
      fObjTrendLine("Cross",fMyTime(x),cy,fMyTime(x),cy,false,Red,7,0,0,false); //  
   }
   else{
      cs=cs+" ";
      ObjectDelete("Cross");
   }
   
   Comment(cs);
   
   return(0);
  }
//+------------------------------------------------------------------+

bool FiboChanLevelAndTrendLnCross(int fx1,double fy1,int fx2,double fy2,double fx3,double fy3,double lev,double lx1,double ly1,double lx2,double ly2,double & cx,double & cy){
      if(fx1==fx2){
         double y1=fy1;
         double y2=fy2;
         double x=(fx3-fx1)*lev+fx3;
         return(TwoLinesCross(x,y1,x,y2,lx1,ly1,lx2,ly2,cx,cy));
      }
      else{
         FiboChanGetLevelValByShift(fx1,fy1,fx2,fy2,fx3,fy3,lev,fx1,y1);
         FiboChanGetLevelValByShift(fx1,fy1,fx2,fy2,fx3,fy3,lev,fx2,y2);
         return(TwoLinesCross(fx1,y1,fx2,y2,lx1,ly1,lx2,ly2,cx,cy));
      }      
}

bool FiboChanGetLevelValByShift(int x1,double y1,int x2,double y2,int x3,double y3,double aLevel,int aShift,double & aValue){
   if(fGetLineValue_y3(x1,y1,x2,y2,x3,aValue)){
      double h=y3-aValue;
      fGetLineValue_y3(x1,y1,x2,y2,aShift,aValue);
      aValue=aValue+h+aLevel*h;
      return(true);
   }
   else{
      return(false);
   }
}

void FiboChanGetCoords(string aName,double & x1,double & y1,double & x2,double & y2,double & x3,double & y3){
   y1=ObjectGet(aName,OBJPROP_PRICE1);
   y2=ObjectGet(aName,OBJPROP_PRICE2);
   y3=ObjectGet(aName,OBJPROP_PRICE3);
   datetime t1=ObjectGet(aName,OBJPROP_TIME1);
   datetime t2=ObjectGet(aName,OBJPROP_TIME2);   
   datetime t3=ObjectGet(aName,OBJPROP_TIME3);     
      if(t1<=Time[0]){
         x1=iBarShift(NULL,0,t1,false);
      }
      else{
         x1=(Time[0]-t1)/(Period()*60);
      }         
      if(t2<=Time[0]){
         x2=iBarShift(NULL,0,t2,false);
      }
      else{
         x2=(Time[0]-t2)/(Period()*60);
      }
      if(t3<=Time[0]){
         x3=iBarShift(NULL,0,t3,false);
      }
      else{
         x3=(Time[0]-t3)/(Period()*60);
      }
}

void TrendLnGetCoords(string aName,double & x1,double & y1,double & x2,double & y2){
   y1=ObjectGet(aName,OBJPROP_PRICE1);
   y2=ObjectGet(aName,OBJPROP_PRICE2);
   datetime t1=ObjectGet(aName,OBJPROP_TIME1);
   datetime t2=ObjectGet(aName,OBJPROP_TIME2);  
      if(t1<=Time[0]){
         x1=iBarShift(NULL,0,t1,false);
      }
      else{
         x1=(Time[0]-t1)/(Period()*60);
      }         
      if(t2<=Time[0]){
         x2=iBarShift(NULL,0,t2,false);
      }
      else{
         x2=(Time[0]-t2)/(Period()*60);
      }      
}

bool fGetLineValue_y3(double x1,double y1,double x2,double y2,double x3,double & y3){
   double d=x2-x1;
      if(d!=0){
         y3=y1+(x3-x1)*(y2-y1)/d;
         return(true);
      }         
      else{
         return(false);
      }
}

bool TwoLinesCross(double x11,double y11,double x12,double y12,double x21,double y21,double x22,double y22,double & x3,double & y3){
   double w1=x12-x11; 
   double w2=x22-x21;    
   double h1=y12-y11;
   double h2=y22-y21;     
      if(w1==0){
         if(h1==0){
            return(false);
         }
         else{
            if(w2==0){
               return(false);
            }
            else{
               if(h2==0){
                  x3=x11;
                  y3=y22;
               }
               else{
                  x3=x11;
                  y3=y21+(x3-x21)*h2/w2;
               }      
            }   
            
         }
      }
      else{
         if(h1==0){
            if(w2==0){
               if(h2==0){
                  return(false);
               }
               else{
                  x3=x22;
                  y3=y11;                  
               }
            }
            else{
               if(h2==0){
                  return(false);
               }
               else{
                  y3=y11;
                  x3=x21+(y3-y21)*w2/h2;
               }      
            }   
         }
         else{
            if(w2==0){
               if(h2==0){
                  return(false);
               }
               else{
                  x3=x22;
                  y3=y11+(x3-x11)*h1/w1;
               }
            }
            else{
               if(h2==0){
                  y3=y22;
                  x3=x11+(y3-y11)*w1/h1;
               }
               else{
                  double b1=h1/w1;
                  double b2=h2/w2;  
                  double f=b2-b1;
                  if(f==0)return(false);
                  double a1=y11-b1*x11;
                  double a2=y21-b2*x21;   
                  x3=(a1-a2)/f;
                  y3=a1+b1*x3;                  
               }      
            }   
         }      
      }
   return(true);      
}

int fMyTime(int aShift){
      if(aShift<0){
         return(Time[0]+Period()*60*MathAbs(aShift));
      }
   return(Time[aShift]);
}

void fObjTrendLine(
   string aObjectName,  // 1 
   datetime aTime_1,    // 2  1
   double aPrice_1,     // 3  1
   datetime aTime_2,    // 4  2
   double aPrice_2,     // 5  2
   bool aRay=false,     // 6 
   color aColor=Red,    // 7 
   int aWidth=1,        // 8 
   int aWindowNumber=0, // 9 
   int aStyle=0,        // 10 0-STYLE_SOLID, 1-STYLE_DASH, 2-STYLE_DOT, 3-STYLE_DASHDOT, 4-STYLE_DASHDOTDOT
   bool aBack=false     // 11 
   ){
      if(ObjectFind(aObjectName)!=aWindowNumber){
         ObjectCreate(aObjectName,OBJ_TREND,aWindowNumber,aTime_1,aPrice_1,aTime_2,aPrice_2);
      }      
   ObjectSet(aObjectName,OBJPROP_TIME1,aTime_1);
   ObjectSet(aObjectName,OBJPROP_PRICE1,aPrice_1);   
   ObjectSet(aObjectName,OBJPROP_TIME2,aTime_2);       
   ObjectSet(aObjectName,OBJPROP_PRICE2,aPrice_2); 
   ObjectSet(aObjectName,OBJPROP_RAY,aRay);     
   ObjectSet(aObjectName,OBJPROP_COLOR,aColor);
   ObjectSet(aObjectName,OBJPROP_WIDTH,aWidth);
   ObjectSet(aObjectName,OBJPROP_BACK,aBack);
   ObjectSet(aObjectName,OBJPROP_STYLE,aStyle);                
}

